"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const cloud_foundry_1 = require("../../utils/cloud-foundry");
function deploy(context, options, projectRoot) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield cloud_foundry_1.login(context, options);
            const manifestPath = path_1.join(projectRoot, 'manifest.yml');
            yield cloud_foundry_1.writeManifest(context, manifestPath);
            yield cloud_foundry_1.push(context, options, manifestPath);
            context.logger.info('🍏 Successfully published to Cloud Foundry!');
        }
        catch (error) {
            context.logger.error('❌ An error occurred!');
            throw error;
        }
    });
}
exports.deploy = deploy;
//# sourceMappingURL=deploy.js.map