"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const architect_1 = require("@angular-devkit/architect");
const core_1 = require("@angular-devkit/core");
const node_1 = require("@angular-devkit/core/node");
const path_1 = require("path");
const actions_1 = require("./actions");
exports.default = architect_1.createBuilder((options, context) => __awaiter(void 0, void 0, void 0, function* () {
    const root = core_1.normalize(context.workspaceRoot);
    const workspace = new core_1.experimental.workspace.Workspace(root, new node_1.NodeJsSyncHost());
    yield workspace.loadWorkspaceFromHost(core_1.normalize('angular.json')).toPromise();
    if (!context.target) {
        throw new Error('Cannot deploy the application without a target');
    }
    const targets = workspace.getProjectTargets(context.target.project);
    if (!targets || !targets.build || !targets.build.options || !targets.build.options.outputPath) {
        throw new Error('Cannot find the project output directory');
    }
    const projectRoot = path_1.join(core_1.getSystemPath(workspace.root), targets.build.options.outputPath);
    try {
        yield actions_1.build(context, options);
        yield actions_1.deploy(context, options, projectRoot);
    }
    catch (e) {
        context.logger.error(`Error when trying to deploy:`);
        context.logger.error(JSON.stringify(e));
        return { success: false };
    }
    return { success: true };
}));
//# sourceMappingURL=deploy.builder.js.map